# [name]

This buffer attribute class does not construct a VBO. Instead, it uses whatever VBO is passed in constructor and can later be altered via the *buffer* property.
It is required to pass additional params alongside the VBO. Those are: the GL context, the GL data type, the number of components per vertex, the number of bytes per component, and the number of vertices.
The most common use case for this class is when some kind of GPGPU calculation interferes or even produces the VBOs in question.

## Constructor

### [name]( [param:WebGLBuffer buffer], [param:GLenum type], [param:Integer itemSize], [param:Integer elementSize], [param:Integer count] )

*buffer* — Must be a WebGLBuffer.
*type* — One of WebGL Data Types.
*itemSize* — The number of values of the array that should be associated with a particular vertex. For instance, if this attribute is storing a 3-component vector (such as a position, normal, or color), then itemSize should be 3.
*elementSize* — 1, 2 or 4. The corresponding size (in bytes) for the given "type" param.

- gl.FLOAT: 4
- gl.UNSIGNED_SHORT: 2
- gl.SHORT: 2
- gl.UNSIGNED_INT: 4
- gl.INT: 4
- gl.BYTE: 1
- gl.UNSIGNED_BYTE: 1

*count* — The expected number of vertices in VBO.

## Properties

### [property:WebGLBuffer buffer]

The current WebGLBuffer instance.

### [property:Integer count]

The expected number of vertices in VBO.

### [property:Integer itemSize]

How many values make up each item (vertex).

### [property:Integer elementSize]

Stores the corresponding size in bytes for the current *type* property value.

See above (constructor) for a list of known type sizes.

### [property:GLenum type]

A WebGL Data Type describing the underlying VBO contents.

Set this property together with *elementSize*. The recommended way is using the *setType* method.

### [property:Boolean isGLBufferAttribute]

Read-only. Always *true*.

## Methods

### [method:this setBuffer]( buffer )

Sets the *buffer* property.

### [method:this setType]( type, elementSize )

Sets the both *type* and *elementSize* properties.

### [method:this setItemSize]( itemSize )

Sets the *itemSize* property.

### [method:this setCount]( count )

Sets the *count* property.

### [property:Integer version]

A version number, incremented every time the needsUpdate property is set to true.

### [property:Boolean needsUpdate]

Default is *false*. Setting this to true increments [page:GLBufferAttribute.version version].

## Source

[link:https://github.com/mrdoob/three.js/blob/master/src/[path].js src/[path].js]